From 3bf37d4450f30cdbd6f9cbfc40f62c1b16ac0fa7 Mon Sep 17 00:00:00 2001
From: Carl Huang <cjhuang@codeaurora.org>
Date: Tue, 3 Dec 2019 17:42:38 +0800
Subject: [PATCH 069/124] ath11k: fix ath11k_pci rmmod crash

For QCA6390, it needs to free_irq and then disable_msi. Otherwise,
crash happened. Also free other resources during ath11k_pci_remove.
Fixed the typo in ath11k_debug_pdev_destroy and ath11k_debug_soc_destroy.

Tested-on: QCA6390 WLAN.HST.1.0.1-01230-QCAHSTSWPLZ_V2_TO_X86-1

Change-Id: I2b3cc1ba5e6cafe4286f4bf3a9c85039f55c2640
Signed-off-by: Carl Huang <cjhuang@codeaurora.org>
---
 drivers/net/wireless/ath/ath11k/debug.c | 8 ++++----
 drivers/net/wireless/ath/ath11k/pci.c   | 8 +++++++-
 2 files changed, 11 insertions(+), 5 deletions(-)

diff --git a/drivers/net/wireless/ath/ath11k/debug.c b/drivers/net/wireless/ath/ath11k/debug.c
index 2ba2160..8289bca 100644
--- a/drivers/net/wireless/ath/ath11k/debug.c
+++ b/drivers/net/wireless/ath/ath11k/debug.c
@@ -834,8 +834,8 @@ int ath11k_debug_pdev_create(struct ath11k_base *ab)
 
 void ath11k_debug_pdev_destroy(struct ath11k_base *ab)
 {
-	debugfs_remove_recursive(ab->debugfs_ath11k);
-	ab->debugfs_ath11k = NULL;
+	debugfs_remove_recursive(ab->debugfs_soc);
+	ab->debugfs_soc = NULL;
 }
 
 int ath11k_debug_soc_create(struct ath11k_base *ab)
@@ -853,8 +853,8 @@ int ath11k_debug_soc_create(struct ath11k_base *ab)
 
 void ath11k_debug_soc_destroy(struct ath11k_base *ab)
 {
-	debugfs_remove_recursive(ab->debugfs_soc);
-	ab->debugfs_soc = NULL;
+	debugfs_remove_recursive(ab->debugfs_ath11k);
+	ab->debugfs_ath11k = NULL;
 }
 
 void ath11k_debug_fw_stats_init(struct ath11k *ar)
diff --git a/drivers/net/wireless/ath/ath11k/pci.c b/drivers/net/wireless/ath/ath11k/pci.c
index 7517b24..3e1b03b 100644
--- a/drivers/net/wireless/ath/ath11k/pci.c
+++ b/drivers/net/wireless/ath/ath11k/pci.c
@@ -1148,10 +1148,16 @@ static void ath11k_pci_remove(struct pci_dev *pdev)
 	struct ath11k_pci *ab_pci = ath11k_pci_priv(ab);
 
 	set_bit(ATH11K_FLAG_UNREGISTERING, &ab->dev_flags);
+	ath11k_core_deinit(ab);
+
 	ath11k_pci_unregister_mhi(ab_pci);
+
+	ath11k_pci_free_irq(ab);
 	ath11k_pci_disable_msi(ab_pci);
 	ath11k_pci_free_region(ab_pci);
-	ath11k_pci_free_irq(ab);
+
+	ath11k_hal_srng_deinit(ab);
+	ath11k_ce_free_pipes(ab);
 	ath11k_core_free(ab);
 }
 
-- 
2.7.4

